package com.boman.gen.api;

import com.boman.domain.GenTable;
import com.boman.domain.constant.ServiceNameConstants;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;

/**
 * 生成代码模块，远程调用入口，如需其他接口，在此添加
 *
 * @author shiqian
 * @date 2021年04月06日 14:22
 **/
@FeignClient(contextId = "remoteLoadTableService", value = ServiceNameConstants.GEN_SERVICE)
public interface RemoteLoadTableService {

    /**
     * 功能描述: 查询代码生成列表，table中封装columnList
     *
     * @param genTable 查询条件
     * @return AjaxResult
     */
    @GetMapping(value = "/init/loadTable")
    void loadTable(GenTable genTable);
}
