package com.boman.system.service.impl;

import com.boman.domain.dto.RoleMenuDto;
import com.boman.system.domain.SysRoleMenu;

import java.util.List;

/**
 * 参数配置 服务层
 *
 * @author ruoyi
 */
public interface ISysRoleMenuService {

    /**
     * 功能描述: 批量保存roleMenu
     *
     * @param dtos dtos
     * @return int
     */
    int saveList(List<RoleMenuDto> dtos);

    /**
     * 功能描述: 根据roleIdList删除
     *
     * @param roleIdList roleIdList
     * @param menuIdList menuIdList
     * @return int
     */
    int deleteByRoleIdList(List<Long> roleIdList, List<Long> menuIdList);

    /**
     * 功能描述: 批量保存roleMenuList
     *
     * @param roleMenuList roleMenuList
     * @return int
     */
    int batchRoleMenu(List<SysRoleMenu> roleMenuList);

    /**
     * 功能描述: 根据roleId和menuId查找
     *
     * @param roleId roleId
     * @param menuId menuId
     * @return java.util.List<com.boman.system.domain.SysRoleMenu>
     */
    SysRoleMenu listByRoleIdMenuId(Long roleId, Long menuId);

    /**
     * 功能描述: 根据roleId和menuIdList查找
     *
     * @param roleId     roleId
     * @param menuIdList menuIdList
     * @return java.util.List<com.boman.system.domain.SysRoleMenu>
     */
    List<SysRoleMenu>  listByRoleIdMenuIdList(Long roleId, List<Long> menuIdList);

    /**
     * 功能描述: 根据roleId和menuId查找
     *
     * @param roleId roleId
     * @return java.util.List<com.boman.system.domain.SysRoleMenu>
     */
    List<SysRoleMenu> listByRoleId(Long roleId);


}
