package com.boman.web.core.service.jflow.impl;

import com.boman.domain.dto.AjaxResult;
import com.boman.domain.dto.ProcessDto;
import com.boman.jflow.api.RemoteJflowProcessService;
import com.boman.jflow.api.RemoteJflowTaskService;
import com.boman.web.core.service.jflow.JFlowProcessService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

@Service
public class JFlowProcessServiceImpl implements JFlowProcessService {

    @Autowired
    private RemoteJflowProcessService remoteJflowProcessService;

    @Override
    public AjaxResult launch(ProcessDto processDto) {
        return remoteJflowProcessService.launch(processDto);
    }


    /**
     * 功能描述: 强制关闭流程
     *
     * @param processDto businessCodes=1,2 hardShut=true
     * @return com.boman.domain.dto.AjaxResult
     */
    @Override
    public AjaxResult shut(ProcessDto processDto) {
        return remoteJflowProcessService.shut(processDto);
    }
}
